unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    DateEdit: TEdit;
    LogMemo: TMemo;
    Button1: TButton;
    Label2: TLabel;
    CalcEdit: TEdit;
    Button2: TButton;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    URLEdit: TEdit;
    Button3: TButton;
    TabSheet4: TTabSheet;
    Label4: TLabel;
    EditA: TEdit;
    Button4: TButton;
    Label5: TLabel;
    EditB: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses PatternEngine;

procedure TForm1.Button1Click(Sender: TObject);
var
  pat: TPattern;
  day,month,year,sep: string;
begin
  // Create pattern
  pat:=PSE([
      PSE([PSEDigit,PSEDigit])[day],
      PSEChar('/. ')[sep],
      PSEOneOf([
        PSE([PSEDigit,PSEDigit]),
        PSEOneOf(['jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec'])
      ])[month],
      PSEVar(sep), // must be same separator as between day and month
      PSE([PSEDigit, PSEDigit, PSEMayBe([PSEDigit,PSEDigit]) ])[year] // 2 or 4 digits for year
    ]);
  try
    pat.Activate(DateEdit.Text);
    if pat.Match then begin
      // Match OK
      LogMemo.Lines.Add('Valid date');
      LogMemo.Lines.Add('Day: '+day);
      LogMemo.Lines.Add('Month: '+month);
      LogMemo.Lines.Add('Year: '+year);
    end else
      LogMemo.Lines.Add('Invalid date');
  finally
    pat.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var pat: TPattern;
    num1, num2, sign: string;
    res: double;
begin
  // Create pattern
  pat:=PSE([
      PSECharSet(' '#0), // may be some spaces
      PSENumber[num1],
      PSECharSet(' '#0), // may be some spaces
      PSEChar('+-*/')[sign],
      PSECharSet(' '#0), // may be some spaces
      PSENumber[num2],
      PSECharSet(' '#0)  // may be some spaces
    ]);
  try
    // Activate pattern on some string
    pat.Activate(CalcEdit.Text);
    if pat.Match then begin // Math OK
      case sign[1] of
        '+': res:=StrToFloat(num1) + StrToFloat(num2);
        '-': res:=StrToFloat(num1) - StrToFloat(num2);
        '*': res:=StrToFloat(num1) * StrToFloat(num2);
        '/': res:=StrToFloat(num1) / StrToFloat(num2);
      end;
      LogMemo.Lines.Add(CalcEdit.Text+' = '+FloatToStr(res));
    end else
      LogMemo.Lines.Add('Invalid expression syntax');
    // Free pattern
  finally
    pat.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CalcEdit.Text:='843'+DecimalSeparator+'4 + 45';
end;

procedure TForm1.Button3Click(Sender: TObject);
  function PSEHost: TPattern;
  begin
    Result:=PSE([PSEChar('a..zA..Z_-0..9.'),PSECharSet('a..zA..Z_-0..9.'#0)]);
  end;
var pat: TPattern;
    proto,user,pswd,host,port,dir,args: string;
begin
  // Create pattern
  pat:=PSE([
      PSEMayBe([PSEIdent[proto], '://']),
      PSEMayBe([PSEIdent[user], PSEMayBe([':', PSEIdent[pswd]]), '@']),
      PSEHost[host],
      PSEMayBe([':', PSEDigits[port]]),
      PSEMayBe(['/',
        PSEAny[dir],
        PSEMayBe(['?', PSEAny[args]])
      ])
    ]);
  try
    // Activate pattern on some string
    pat.Activate(URLEdit.Text);
    if pat.Match then begin // Math OK
      LogMemo.Lines.Add('Protocol: '+proto);
      LogMemo.Lines.Add('User: '+user);
      LogMemo.Lines.Add('Password: '+pswd);
      LogMemo.Lines.Add('Host: '+host);
      LogMemo.Lines.Add('Port: '+port);
      LogMemo.Lines.Add('Dir: '+dir);
      LogMemo.Lines.Add('Arguments: '+args);
    end else
      LogMemo.Lines.Add('Invalid URL syntax');
    // Free pattern
  finally
    pat.Free;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var pat: TPattern;
    str,maxstr: string;
begin
  // Create pattern
  pat:=PSE([PSEAny, PSEAnyStr[str],
            PSEAny, '||||', PSEAny, PSEVar(str), PSEAny]);
  try
    // Activate pattern on some string
    pat.Activate(EditA.Text + '||||' + EditB.Text);
    maxstr:='';
    // for all successful matches
    while pat.Match do begin
      if Length(str) > Length(maxstr) then begin
        LogMemo.Lines.Add('Found "'+str+'"');
        maxstr:=str;
      end;
      pat.MatchNext;
    end;
  finally
    pat.Free;
  end;
  // Write result
  if maxstr <> '' then
    LogMemo.Lines.Add('Max substring is "'+maxstr+'"')
  else
    LogMemo.Lines.Add('Max substring not found');
end;

end.
